// Program wc (a la unix wordcount "wc")
// version:0.03
// modified from mars by Larry Cowan March 17, 2004

// Notes: No protection is included against overlapping patterns.  Files
//          will be listed multiple times.
//        Recursion code can be interspersed with patterns, it operates as
//          a flip-flop switch.          

import std.file;
import expandw;
  // uses parsestring;
  // uses wildmatch;

int main (char[][] args)
{
    int w_total = 0;
    int l_total = 0;
    int c_total = 0;
    int fcnt = 0;
    bit recurse = false;
    WildCard wc = new WildCard();

    if (args.length < 2) {
        printf("Usage: [-r] filename-pattern[s]\n");
        return 1;
    }
    printf ("   lines   words   bytes file\n");
    foreach ( char[] wildarg; args[1 .. args.length] )
    {
        if (wildarg == "-r") {
            recurse = !recurse;
            continue;
        }

        debug (wc) printf("Pattern: %.*s %.*s\n",wildarg,(recurse ? "(R)":""));

        char[][] fnlist = wc.expand(wildarg,(recurse ? 'r':0));
        foreach ( char[] fn; fnlist ) {
            char[] input;
            int w_cnt = 0;
            int l_cnt = 0;
            int c_cnt = 0;
            int inword = 0;
        
            ++fcnt;
            input = cast(char[])std.file.read(fn);
        
            foreach (char c; input)
            {
                if (c == '\n')
                    ++l_cnt;
                if (c != ' ')
                {
            	    if (!inword)
                    {
                        inword = 1;
                        ++w_cnt;
                    }
                } else
            	    inword = 0;
                ++c_cnt;
            }
            printf ("%8lu%8lu%8lu %.*s\n", l_cnt, w_cnt, c_cnt, fn);

            l_total += l_cnt;
            w_total += w_cnt;
            c_total += c_cnt;
        }
    }
    if (fcnt > 1)
    {
        printf ("----------------------------------------------\n");
        printf ("%8lu%8lu%8lu totals for %d files",
	            l_total, w_total, c_total, fcnt);
    }
    return 0;
}
